@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!/sw/bin/perl
#line 14

$self = $0;
$self =~ s!^.*/!!;

$path = "/usr/develop/modules/";
$module = "current";

$source = $path;
$target = $path;

$source =~ s!/+$!!;
$target =~ s!/+$!!;

$dist = shift;

unless ($dist =~ /^(?:BASE|SPU|KM)$/)
{
    die "$self: illegal target '$dist' (BASE|SPU|KM)!\n";
}

$source .= "/$module";

if (-e $source)
{
    unless (-l $source)
    {
        die "$self: '$source' is not a symbolic link!\n";
    }
    $link = readlink($source);
    if ($link =~ m!^([a-zA-Z0-9_]+)-([a-zA-Z0-9_]+)-(\d+(?:\.\d+)*[ab]?)$!)
    {
        $maj = $1;
        $min = $2;
        $ver = $3;
        if ($maj eq 'DCAG')
        {
            if ($min eq $dist)
            {
                die "$self: already in that distribution!\n";
            }
            else
            {
                $name = "$module.$min";
            }
        }
        else
        {
            $ver =~ s!\.!!g;
            $name = $module . "."
                            . uc(substr($maj,0,1))
                            . uc(substr($min,0,1))
                            . $ver;
        }
    }
    else
    {
        die "$self: can't grok symbolic link '$link'!\n";
    }
    $target .= "/$name";
    if (-e $target)
    {
        die "$self: can't rename '$source' to '$target': file exists!\n";
    }
    else
    {
        if (rename($source,$target))
        {
            warn "$self: renamed '$source' to '$target'.\n";
        }
        else
        {
            die "$self: couldn't rename '$source' to '$target': $!\n";
        }
    }
}

$target = $source;
$source .= ".$dist";

if (-l $source)
{
    if (-e $target)
    {
        die "$self: can't rename '$source' to '$target': file exists!\n";
    }
    else
    {
        if (rename($source,$target))
        {
            warn "$self: renamed '$source' to '$target'.\n";
        }
        else
        {
            die "$self: couldn't rename '$source' to '$target': $!\n";
        }
    }
}
else
{
    die "$self: symbolic link '$source' does not exist!\n";
}

__END__
:endofperl
